
#include <iostream>
#include "generic_object.h"


using namespace std;

// Constructor - initialize private members
generic_object::generic_object(GLfloat *posit, GLfloat *col, GLfloat dot)
{
	pos[0] = posit[0];
	pos[1] = posit[1];

	colour[0] = col[0];
	colour[1] = col[1];
	colour[2] = col[2];

	markerColour[0] = col[0];
	markerColour[1] = col[1];
	markerColour[2] = col[2];

	dotSize = dot;
	markerSize = 2.0f;
}

// Method that sets the position of the object
void generic_object::setPosition(GLfloat *newPos)
{
	pos[0] = newPos[0];
	pos[1] = newPos[1];
}

// Method that sets the colour of the object
void generic_object::setColour(GLfloat *col)
{
	colour[0] = col[0];
	colour[1] = col[1];
	colour[2] = col[2];
}

// Method that sets the size of the object
void generic_object::setDotSize(GLfloat dot)
{
	dotSize = dot;
}

// Method that sets the size of the marker that highlights the object
void generic_object::setMarkerSize(GLfloat marker)
{
	markerSize = marker;
}

// Method that sets the colour of the object
void generic_object::setMarkerColour(GLfloat *cl)
{
	markerColour[0] = cl[0];
	markerColour[1] = cl[1];
	markerColour[2] = cl[2];
}

// Returns the x and y coordinates of the object
void generic_object::getPosition(GLfloat *ipos)
{
	ipos[0] = pos[0];
	ipos[1] = pos[1];
}

// Method that draws the object at the given location
void generic_object::draw(GLfloat newX, GLfloat newY)
{
	glColor3f(colour[0], colour[1], colour[2]);
	glPointSize(dotSize);
	glBegin(GL_POINTS);
		glVertex3f(newX, newY, 0.0f);
	glEnd();

	glColor3f(markerColour[0], markerColour[1], markerColour[2]);
	glPointSize(markerSize);
	glBegin(GL_POINTS);
		glVertex3f(newX, newY, 0.0f);
	glEnd();
}

// Method that draws the object at the current location
void generic_object::draw()
{
	glColor3f(colour[0], colour[1], colour[2]);
	glPointSize(dotSize);
	glBegin(GL_POINTS);
		glVertex3f(pos[0], pos[1], 0.0f);
	glEnd();

	glColor3f(markerColour[0], markerColour[1], markerColour[2]);
	glPointSize(markerSize);
	glBegin(GL_POINTS);
		glVertex3f(pos[0], pos[1], 0.0f);
	glEnd();
}