////////////////////////////////////////////////
// FILE:  simulation.h
// Defines an object that runs the simulation of game objects
// Uses the FFLL API - http://sourceforge.net/projects/ffll/
////////////////////////////////////////////////

#ifndef SIMULATION_H
#define SIMULATION_H

#include <FFLLAPI.h>
#include <GL/glut.h>

class simulation {
private:
	int fuzzy_position;
	int fuzzy_position2;
	int position_child;
	int position2_child;
	int fuzzy_velocity;
	int velocity_child;
	float stepSize;

public:
	// constructor
	simulation(int sSize);

	// method that uses fuzzy logic to generate new velocity/coordinates
	void nextStep(GLfloat *player_pos, GLfloat *player2_pos, GLfloat *puck_pos, GLfloat *tm_pos, GLfloat *opp_pos, short int &possession, short int &game_score, unsigned short int &game_time);
};

#endif // SIMULATION_H